Package com.io7m.cardant.model

# Record Class CAItemID

java.lang.Object
java.lang.Record
com.io7m.cardant.model.CAItemID

Record Components:
  `id` - The ID value

All Implemented Interfaces:
  `CAIdType`, `Comparable<CAItemID>`

public record CAItemID(UUID id) extends Record implements Comparable<CAItemID>, CAIdType
The unique ID of an item.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CAItemID(UUID id)`
  The unique ID of an item.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `compareTo(CAItemID other)`
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `UUID`
  `id()`
  Returns the value of the `id` record component.
  `static CAItemID`
  `of(String id)`
  Construct an ID.
  `static CAItemID`
  `of(UUID id)`
  Construct an ID.
  `static CAItemID`
  `random()`
  Construct an ID using a pseudorandom value.
  `String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.cardant.model.CAIdType

  `displayId`

- ## Constructor Details

  - ### CAItemID

    public CAItemID(UUID id)
    The unique ID of an item.
    Parameters:
      `id` - The ID value

- ## Method Details

  - ### toString

    public String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### of

    public static CAItemID of(String id)
    Construct an ID.
    Parameters:
      `id` - The ID value
    Returns:
      An ID

  - ### of

    public static CAItemID of(UUID id)
    Construct an ID.
    Parameters:
      `id` - The ID value
    Returns:
      An ID

  - ### random

    public static CAItemID random()
    Construct an ID using a pseudorandom value.
    Returns:
      An ID

  - ### compareTo

    public int compareTo(CAItemID other)
    Specified by:
      `compareTo` in interface `Comparable<CAItemID>`

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### id

    public UUID id()
    Returns the value of the `id` record component.
    Specified by:
      `id` in interface `CAIdType`
    Returns:
      the value of the `id` record component